﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FeclDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {

            fecllib.Fecl wsfecl = new fecllib.Fecl();
            String ArchivoCertificado = wsfecl.RutaLibreria + "recursos\\certificado.pfx";
            String Clave = "feafip";

            wsfecl.ModoProduccion = false;
            wsfecl.ModoSimulacion = true; // Cambiar a falso para trabajar con servidores reales de SII

            try
            {
                if (!wsfecl.Autenticar(ArchivoCertificado, Clave))
                {
                    throw new Exception(wsfecl.ErrorDesc);
                }

                fecllib.EnvioDTE vEnvio = wsfecl.NuevoEnvioDTE();
                vEnvio.ArchivoCertificado = ArchivoCertificado;
                vEnvio.ArchivoClave = Clave;

                //Descripcion: www.sii.cl/factura_electronica/factura_mercado/formato_dte.pdf
                //Diagrama: www.bitingenieria.com.ar/doc/descripcion_dte

                vEnvio.SDTE.get_Nodo("Caratula").get_Nodo("RutEmisor").ValueStr = "22222222-2";
                vEnvio.SDTE.get_Nodo("Caratula").get_Nodo("RutEnvia").ValueStr = "11111111-1";
                vEnvio.SDTE.get_Nodo("Caratula").get_Nodo("RutReceptor").ValueStr = "60803000-K";
                vEnvio.SDTE.get_Nodo("Caratula").get_Nodo("FchResol").ValueStr = "2016-04-27";
                vEnvio.SDTE.get_Nodo("Caratula").get_Nodo("NroResol").ValueInt = 0;
                vEnvio.SDTE.get_Nodo("Caratula").get_Nodo("TmstFirmaEnv").ValueStr = "";
                vEnvio.SDTE.get_Nodo("Caratula").get_Nodos("SubTotDTE", 0).get_Nodo("TpoDTE").ValueInt = 33;
                vEnvio.SDTE.get_Nodo("Caratula").get_Nodos("SubTotDTE", 0).get_Nodo("NroDTE").ValueInt = 1;

                fecllib.Nodo vDoc = vEnvio.SDTE.get_Nodos("DTE", 0).get_Nodo("Documento");

                vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("TipoDTE").ValueInt = vEnvio.SDTE.get_Nodo("Caratula").get_Nodos("SubTotDTE", 0).get_Nodo("TpoDTE").ValueInt;
                vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("Folio").ValueInt = 1;
                vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("FchEmis").ValueStr = "2017-08-31";

                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("RUTEmisor").ValueStr = vEnvio.SDTE.get_Nodo("Caratula").get_Nodo("RutEmisor").ValueStr;
                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("RznSoc").ValueStr = "Razon social emisor";
                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("GiroEmis").ValueStr = "Venta de articulos de cotillón";
                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("Acteco").ValueStr = "11111";
                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("DirOrigen").ValueStr = "Direccion Origen 1234";
                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("CmnaOrigen").ValueStr = "Santiago";

                vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("RUTRecep").ValueStr = vEnvio.SDTE.get_Nodo("Caratula").get_Nodo("RutReceptor").ValueStr;
                vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("RznSocRecep").ValueStr = "Receptor del documento";
                vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("GiroRecep").ValueStr = "Giro Receptor";
                vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("DirRecep").ValueStr = "Direccion del receptor";
                vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("CmnaRecep").ValueStr = "Comuna Receptor";

                vDoc.get_Nodo("Encabezado").get_Nodo("Totales").get_Nodo("MntNeto").ValueDbl = 171639;
                vDoc.get_Nodo("Encabezado").get_Nodo("Totales").get_Nodo("TasaIVA").ValueDbl = 19;
                vDoc.get_Nodo("Encabezado").get_Nodo("Totales").get_Nodo("IVA").ValueDbl = 32611;
                vDoc.get_Nodo("Encabezado").get_Nodo("Totales").get_Nodo("MntTotal").ValueDbl = 204250;

                vDoc.get_Nodos("Detalle", 0).get_Nodo("NroLinDet").ValueInt = 1;
                vDoc.get_Nodos("Detalle", 0).get_Nodo("CdgItem").get_Nodo("TpoCodigo").ValueStr = "INT1";
                vDoc.get_Nodos("Detalle", 0).get_Nodo("CdgItem").get_Nodo("VlrCodigo").ValueStr = "011";
                vDoc.get_Nodos("Detalle", 0).get_Nodo("NmbItem").ValueStr = "Cajón AFECTO";
                vDoc.get_Nodos("Detalle", 0).get_Nodo("QtyItem").ValueInt = 122;
                vDoc.get_Nodos("Detalle", 0).get_Nodo("PrcItem").ValueDbl = 833;
                vDoc.get_Nodos("Detalle", 0).get_Nodo("MontoItem").ValueDbl = 101626;

                vDoc.get_Nodos("Detalle", 1).get_Nodo("NroLinDet").ValueInt = 2;
                vDoc.get_Nodos("Detalle", 1).get_Nodo("CdgItem").get_Nodo("TpoCodigo").ValueStr = "INT2";
                vDoc.get_Nodos("Detalle", 1).get_Nodo("CdgItem").get_Nodo("VlrCodigo").ValueStr = "0231";
                vDoc.get_Nodos("Detalle", 1).get_Nodo("NmbItem").ValueStr = "Relleno AFECTO";
                vDoc.get_Nodos("Detalle", 1).get_Nodo("QtyItem").ValueInt = 53;
                vDoc.get_Nodos("Detalle", 1).get_Nodo("PrcItem").ValueDbl = 1321;
                vDoc.get_Nodos("Detalle", 1).get_Nodo("MontoItem").ValueDbl = 70013;

                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("RE").ValueStr = vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("RUTEmisor").ValueStr;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("TD").ValueInt = vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("TipoDTE").ValueInt;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("F").ValueInt = vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("Folio").ValueInt;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("FE").ValueStr = vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("FchEmis").ValueStr;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("RR").ValueStr = vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("RUTRecep").ValueStr;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("RSR").ValueStr = vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("RznSocRecep").ValueStr;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("MNT").ValueDbl = vDoc.get_Nodo("Encabezado").get_Nodo("Totales").get_Nodo("MntTotal").ValueDbl;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("IT1").ValueStr = vDoc.get_Nodos("Detalle", 0).get_Nodo("NmbItem").ValueStr;

                if (!vEnvio.AgregarTED(wsfecl.RutaLibreria + "recursos\\folio_dte.xml"))
                {
                    throw new Exception(vEnvio.ErrorDesc);
                }

                if (!vEnvio.Firmar())
                {
                    throw new Exception(vEnvio.ErrorDesc);
                }

                if (!wsfecl.EnviarDTE())
                {
                    throw new Exception(vEnvio.ErrorDesc);
                }

                vEnvio.Impresion.AbrirArchivo = true;
                if (!vEnvio.Impresion.Generar(0, wsfecl.RutaLibreria + "pdf\\dte.pdf", wsfecl.RutaLibreria + "recursos\\plantilla_dte.rtm", "PDF"))
                {
                    throw new Exception(vEnvio.Impresion.ErrorDesc);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
        
            fecllib.Fecl wsfecl = new fecllib.Fecl();
            String ArchivoCertificado = wsfecl.RutaLibreria + "recursos\\certificado.pfx";
            String Clave = "feafip";

            wsfecl.ModoProduccion = false;
            wsfecl.ModoSimulacion = true; // Cambiar a falso para trabajar con servidores reales de SII

            try {
                if (!wsfecl.Autenticar(ArchivoCertificado, Clave)) {
                    throw new Exception(wsfecl.ErrorDesc);
                }

                fecllib.EnvioBoleta vEnvioBoleta = wsfecl.NuevoEnvioBoleta();
                vEnvioBoleta.ArchivoCertificado = ArchivoCertificado;
                vEnvioBoleta.ArchivoClave = Clave;

                //Descripcion: www.sii.cl/factura_electronica/factura_mercado/boletas_elec_0720_3.pdf
                //Diagrama: www.bitingenieria.com.ar/doc/boletas_elec

                vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodo("RutEmisor").ValueStr = "22222222-2";
                vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodo("RutEnvia").ValueStr = "11111111-1";
                vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodo("RutReceptor").ValueStr = "60803000-K";
                vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodo("FchResol").ValueStr = "2016-04-27";
                vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodo("NroResol").ValueInt = 0;
                vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodo("TmstFirmaEnv").ValueStr = "";
                vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodos("SubTotDTE", 0).get_Nodo("TpoDTE").ValueInt = 39;
                vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodos("SubTotDTE", 0).get_Nodo("NroDTE").ValueInt = 1;

                fecllib.Nodo vDoc = vEnvioBoleta.SetDTE.get_Nodos("DTE", 0).get_Nodo("Documento");

                vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("TipoDTE").ValueInt = vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodos("SubTotDTE", 0).get_Nodo("TpoDTE").ValueInt;
                vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("Folio").ValueInt = 1;
                vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("FchEmis").ValueStr = "2017-08-31";
                vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("IndServicio").ValueInt = 3;

                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("RUTEmisor").ValueStr = vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodo("RutEmisor").ValueStr;
                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("RznSocEmisor").ValueStr = "RAZON_SOCIAL";
                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("GiroEmisor").ValueStr = "Venta de articulos de cotillón";
                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("DirOrigen").ValueStr = "Direccion Origen 1234";
                vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("CmnaOrigen").ValueStr = "Santiago";

                vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("RUTRecep").ValueStr = vEnvioBoleta.SetDTE.get_Nodo("Caratula").get_Nodo("RutReceptor").ValueStr;
                vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("RznSocRecep").ValueStr = "Receptor del documento";
                vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("DirRecep").ValueStr = "Direccion Receptor";
                vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("CmnaRecep").ValueStr = "Comuna Receptor";

                vDoc.get_Nodo("Encabezado").get_Nodo("Totales").get_Nodo("MntTotal").ValueDbl = 204250;

                vDoc.get_Nodos("Detalle", 0).get_Nodo("NroLinDet").ValueInt = 1;
                vDoc.get_Nodos("Detalle", 0).get_Nodo("NmbItem").ValueStr = "Cajón AFECTO";
                vDoc.get_Nodos("Detalle", 0).get_Nodo("PrcItem").ValueDbl = 833;
                vDoc.get_Nodos("Detalle", 0).get_Nodo("MontoItem").ValueDbl = 101626;

                vDoc.get_Nodos("Detalle", 1).get_Nodo("NroLinDet").ValueInt = 2;
                vDoc.get_Nodos("Detalle", 1).get_Nodo("NmbItem").ValueStr = "Relleno AFECTO";
                vDoc.get_Nodos("Detalle", 1).get_Nodo("PrcItem").ValueDbl = 1321;
                vDoc.get_Nodos("Detalle", 1).get_Nodo("MontoItem").ValueDbl = 70013;

                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("RE").ValueStr = vDoc.get_Nodo("Encabezado").get_Nodo("Emisor").get_Nodo("RUTEmisor").ValueStr;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("TD").ValueInt = vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("TipoDTE").ValueInt;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("F").ValueInt = vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("Folio").ValueInt;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("FE").ValueStr = vDoc.get_Nodo("Encabezado").get_Nodo("IdDoc").get_Nodo("FchEmis").ValueStr;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("RR").ValueStr = vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("RUTRecep").ValueStr;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("RSR").ValueStr = vDoc.get_Nodo("Encabezado").get_Nodo("Receptor").get_Nodo("RznSocRecep").ValueStr;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("MNT").ValueDbl = vDoc.get_Nodo("Encabezado").get_Nodo("Totales").get_Nodo("MntTotal").ValueDbl;
                vDoc.get_Nodo("TED").get_Nodo("DD").get_Nodo("IT1").ValueStr = vDoc.get_Nodos("Detalle", 0).get_Nodo("NmbItem").ValueStr;

                if (!vEnvioBoleta.AgregarTED(wsfecl.RutaLibreria + "recursos\\folio_boleta.xml")) {
                    throw new Exception(vEnvioBoleta.ErrorDesc);
                }

                if (!vEnvioBoleta.Firmar()) {
                    throw new Exception(vEnvioBoleta.ErrorDesc);
                }

                if (!wsfecl.EnviarBoleta()) {
                    throw new Exception(vEnvioBoleta.ErrorDesc);
                }

                vEnvioBoleta.Impresion.AbrirArchivo = true;
                if (!vEnvioBoleta.Impresion.Generar(0, wsfecl.RutaLibreria + "pdf\\boleta.pdf", wsfecl.RutaLibreria + "recursos\\plantilla_boleta.rtm", "PDF")) {
                    throw new Exception(vEnvioBoleta.Impresion.ErrorDesc);
                }
            } catch(Exception ex) {
                MessageBox.Show(ex.Message);
            }
        }

    }
}
