import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JOptionPane;

import com.bitingenieria.fecl.*;

public class MainClass {

	public static void main(String[] args) {
/*		Para poder evaluar necesitas las siguienets condiciones:
		Poseer un certificado y claves en formato PFX o PEM
		Poseer un archivo de folios solicitado a SII (https://maullin.sii.cl/cvc_cgi/dte/of_solicita_folios)
		Registrar la fecl ejecutando FECLRegistrar.exe
		Modificar los datos del emisor en el proyecto acorde a los datos de la empresa (Se pueden obtener de la web de SII)
*/		  
//		SI EL CERTIFICADO ES PFX
		  String archivoCertificado = "certificado.pfx";
		  String clave = "feafip";
		  
//		  SI EL CERTIFICADO ES CRT(PEM)
//		  Const archivoCertificado = "C:\\Datos\\certificado.crt";
//		  Const clave = "C:\\Datos\\clave.key";
		  
		  
//		  ARCHIVO DE FOLIO DESCARGADO DE LA PAGINA DE SII
		  String archivoFolio = "folios.xml";
		  
//		  Numero de Folio
		  int folio = 5;
		
		IFecl vFecl = ClassFactory.createFecl();
		vFecl.modoProduccion(false);
		vFecl.modoSimulacion(true);
		
		if (vFecl.autenticar(archivoCertificado, clave)) {

			IEnvioDTE vEnvio = vFecl.nuevoEnvioDTE();
		    
		    ICaratula vCar = vEnvio.setDTE().caratula();
		    vCar.rutEmisor("22222222-2");
		    vCar.rutEnvia("111111-1");
		    vCar.rutReceptor("60803000-K");
		    vCar.fchResol("2016-04-27");
		    vCar.nroResol(0);
		    vCar.tmstFirmaEnv("");
		    vCar.agregaSubTotDTE(33, 1);
		  
		    IDocumento vDoc = vEnvio.setDTE().dte(0).documento();
		    vDoc.encabezado().idDoc().tipoDte(33);
			vDoc.encabezado().idDoc().folio(folio);
		    vDoc.encabezado().idDoc().fchEmis(new SimpleDateFormat("yyyy-MM-dd").format(new Date()));
		    
		    vDoc.encabezado().emisor().rutEmisor("22222222-2");
		    vDoc.encabezado().emisor().rznSoc("RAZON SOCIAL EMISOR");
		    vDoc.encabezado().emisor().giroEmis("Giro emisor");
		    vDoc.encabezado().emisor().agregaActeco(523999);
		    vDoc.encabezado().emisor().dirOrigen("Direccin emisor");
		    vDoc.encabezado().emisor().cmnaOrigen("Santiago");

		    vDoc.encabezado().receptor().rutRecep("33333333-3");
		    vDoc.encabezado().receptor().rznSocRecep("RAZON SOCIAL RECEPTOR");
		    vDoc.encabezado().receptor().giroRecep("Giro Receptor");
		    vDoc.encabezado().receptor().dirRecep("Direccin Receptor");
		    vDoc.encabezado().receptor().cmnaRecep("Santiago");

		    vDoc.encabezado().totales().mntNeto(171639);
		    vDoc.encabezado().totales().tasaIVA(19);
		    vDoc.encabezado().totales().iva(32611);
		    vDoc.encabezado().totales().mntTotal(204250);

		    vDoc.detalle(0).nroLinDet(1);
		    vDoc.detalle(0).tpoCodigo("INT1");
		    vDoc.detalle(0).vlrCodigo("011");
		    vDoc.detalle(0).nmbItem("Cajn AFECTO");
		    vDoc.detalle(0).dscItem("Cajn AFECTO");
		    vDoc.detalle(0).qtyItem(122);
		    vDoc.detalle(0).prcItem(833);
		    vDoc.detalle(0).montoItem(101626);

		    vDoc.detalle(1).nroLinDet(2);
		    vDoc.detalle(1).tpoCodigo("INT1");
		    vDoc.detalle(1).vlrCodigo("0231");
		    vDoc.detalle(1).nmbItem("Relleno AFECTO");
		    vDoc.detalle(1).dscItem("Relleno AFECTO");
		    vDoc.detalle(1).qtyItem(53);
		    vDoc.detalle(1).prcItem(1321);
		    vDoc.detalle(1).montoItem(70013);
		    
		    vDoc.ted().re(vDoc.encabezado().emisor().rutEmisor());
		    vDoc.ted().td(vDoc.encabezado().idDoc().tipoDte());
		    vDoc.ted().f(vDoc.encabezado().idDoc().folio());
		    vDoc.ted().fe(vDoc.encabezado().idDoc().fchEmis());
		    vDoc.ted().rr(vDoc.encabezado().receptor().rutRecep());
		    vDoc.ted().rsr(vDoc.encabezado().receptor().rznSocRecep());
		    vDoc.ted().mnt(vDoc.encabezado().totales().mntTotal());
		    vDoc.ted().iT1(vDoc.detalle(0).dscItem());
			vDoc.ted().caf().cargaDesdeArchivo(archivoFolio);
		     
		    vEnvio.firma();
		     
		    if (vFecl.enviarDTE()){
		      JOptionPane.showMessageDialog(null, "DTE enviado con xito! TrackID: " + vFecl.trackID());
		     
		      vEnvio.almacenar("dte_firmado.xml");
		      
		      // Eliminar comentario para disear la plantilla
		      //vEnvio.impresion().editar(0, "plantilla.rtm");
		      
		      vEnvio.impresion().abrirArchivo(true);
		      vEnvio.impresion().generar(0, "factura_electronica.pdf", "plantilla.rtm", "PDF");
		      
		    } else {
		      JOptionPane.showMessageDialog(null, vFecl.errorDesc()); 
		    }
		} else {
			JOptionPane.showMessageDialog(null, vFecl.errorDesc());
		}; 
	}

}
